#include "allegui.h"
//
#ifndef _TDGUI_H_
#define _TDGUI_H_
//
#ifdef  __cplusplus
extern "C" {
#endif

#define STL_IN  1            //In style. looks like start button.
                             //(this is different from a standard button)   
#define STL_DOWN  STL_IN     //Same as above.
#define STL_OUT  2           //Opposite of STL_IN
#define STL_UP  STL_OUT      //Same as above.
#define STL_FLAT 4           //Makes faces of objects grey.
#define STL_FILLED STL_FLAT  //Same as above.
#define STL_FACE STL_FLAT    //Same as above.
#define STL_FRAME 8          //Used in conjunction with STL_IN to draw a frame.
                             //Frames are drawn differently from other objects.
#define STL_DITHERED 16      //Used for the background of scroll bars.
#define STL_FRAMEFILLED 32   //Fills the backgroud with white for the frames.
#define STL_BUTTONDOWN 64    //Used when you have called set_gui_mode(1).
							 //Buttons are drawn differently than other
                             //"in" objects.
#define STL_TITLEBAR 128     //Window titles and menus.
#define STL_PROGRESSBAR 256

#define SCL_UPBUTTON_DOWN 1  //Flags used with the half-finished scrollbars.
#define SCL_DOWNBUTTON_DOWN 2//(Note: the scrollbars on the ListBox are done.
                             // It's the stand-alone ones that aren't)
#define SCL_UPARROW 4
#define SCL_DOWNARROW 8
#define SCL_LEFTARROW 16
#define SCL_RIGHTARROW 32

#define BILL_CLEAR      -1    /*Set this as BG on windos_text and windos_ctext,
                                If you want. It is negative so that if you
                                are converting an old Allegro dialog, you
                                won't accidentally make clear text by not
                                changing the old value.
                              */
#define BILL_TITLE      -2 
//
extern PDialog ActivateDialog( PApplication App, DIALOG *dlg, int chain, DIALOG_STATE ( *handler )( int c ) );
extern void CloseDialog( PDialog d );
extern void TdBox( BITMAP *b, l_int x, l_int y, l_int w, l_int h, l_int stl );
extern void WindowsInit( void );
extern int DoWindow( DIALOG *dialog, int focus_obj );
extern void _DrawArrow( int x, int y, int basew, int colr, int stl ) ;
extern void FadeBmp( BITMAP *bmp, int clr ) ;
extern void ReplaceColor( BITMAP *b, int oc, int nc );
extern void MakeSolidPalette( PALETTE pal, int start, int stop, int r, int g, int b );
extern int PlayWindow( DIALOG *dialog );
extern int FileSelect( char *message, char *path, char *ext );
extern int MenuAltKey( int k, GUIMENU *m );
extern int DoMenu( GUIMENU *menu, int x, int y );
extern int dMenuProcedure( int msg, DIALOG *d, int c );
extern void _DrawScrollableFrame( DIALOG *d, int listsize, int offset, int height, int fg_color, int bg );
extern void _DrawListBox( DIALOG *d );
extern int ProgressProcedure( int msg, DIALOG *d, int c );
extern int BitmapProcedure( int msg, DIALOG *d, int c );
extern int ScrollableBitmapProcedure( int msg, DIALOG *d, int c );
extern int hScrollbarProcedure( int msg, DIALOG *d, int c );
extern int vScrollbarProcedure( int msg, DIALOG *d, int c );
extern void _DrawTextBox( char *thetext, int *listsize, int draw, int offset, int wword, int tabsize, int x, int y, int w, int h, int disabled, int fore, int deselect, int disable );
extern int TextBoxProcedure( int msg, DIALOG *d, int c );
extern int EditProcedure( int msg, DIALOG *d, int c );
extern int TextProcedure( int msg, DIALOG *d, int c );
extern int CentreTextProcedure( int msg, DIALOG *d, int c );
extern int CheckProcedure( int msg, DIALOG *d, int c );
extern int SliderProcedure( int msg, DIALOG *d, int c );
extern int WindowProcedure( int msg, DIALOG *d, int c );
extern int BarProcedure( int msg, DIALOG *d, int c );
extern int ClearProcedure( int msg, DIALOG *d, int c );
extern int ListProcedure( int msg, DIALOG *d, int c );
extern int RadioProcedure( int msg, DIALOG *d, int c );
extern int dRadioProcedure( int msg, DIALOG *d, int c );
extern int ButtonProcedure( int msg, DIALOG *d, int c );
extern int dExButtonProcedure( int msg, DIALOG *d, int c );
extern int dCallbackButtonProcedure( int msg, DIALOG *d, int c );
extern int IconProcedure( int msg, DIALOG *d, int c );
extern int CallbackIconProcedure( int msg, DIALOG *d, int c );
extern int hLineProcedure( int msg, DIALOG *d, int c );
extern int vLineProcedure( int msg, DIALOG *d, int c );
extern int GroupBoxProcedure( int msg, DIALOG *d, int c );
extern int DdlistCloserProcedure( int msg, DIALOG *d, int c );
extern int DdlistListProcedure( int msg, DIALOG *d, int c );
extern int _OpenListComboBox( DIALOG *d );
extern int DdlistProcedure( int msg, DIALOG *d, int c );
extern int dMenuProcedure( int msg, DIALOG *d, int c );
extern int dExButtonProcedure( int msg, DIALOG *d, int c );
extern int dCallbackButtonProcedure( int msg, DIALOG *d, int c );
extern int ObjectMessage(DIALOG *dialog, int msg, int c);
extern int KeyboardProcedure(int msg, DIALOG *d, int c);
extern void CentreDialog(DIALOG *dialog);
extern int RightTextProcedure(int msg, DIALOG *d, int c);
extern int DialogMessage(DIALOG *dialog, int msg, int c, int *obj);
extern void SetDialogColor(DIALOG *dialog, int fg, int bg);
extern int TextListProcedure(int msg, DIALOG *d, int c);
extern void _HandleListBoxClick( DIALOG *d );
extern void _HandleScrollableScroll( DIALOG *d, int listsize, int *index, int *offset );
extern void _HandleScrollableScrollClick( DIALOG *d, int listsize, int *offset, int height );
extern int YieldProcedure( int msg, DIALOG *d, int c );
extern int PopupDialog( DIALOG *dialog, int focus_obj );
/****************************************************************************/
extern int UpdateWindow( DIALOG_PLAYER *player );
extern int ShutdownDialog( DIALOG_PLAYER *player );
extern DIALOG_PLAYER *InitDialog( DIALOG *dialog, int focus_obj );
extern int GuiTextoutEx( BITMAP *bmp, AL_CONST char *s, int x, int y, int color, int bg, int centre );
extern int GuiStrLen( AL_CONST char *s );
extern int YieldProcedure( int msg, DIALOG *d, int c );
extern int UpdateMenu( GUIMENU_PLAYER *player );
extern GUIMENU_PLAYER *InitMenu( GUIMENU *menu, int x, int y );
extern int ShutdownMenu( GUIMENU_PLAYER *player );
extern int DoDialog( DIALOG *dialog, int focus_obj );
extern int PopupDialog( DIALOG *dialog, int focus_obj );
extern int ShadowBoxProcedure( int msg, DIALOG *d, int c );
extern int BoxProcedure( int msg, DIALOG *d, int c );
/****************************************************************************/
extern int MouseX( void );
extern int MouseY( void );
extern int MouseZ( void );
extern int MouseB( void );
/****************************************************************************/
extern GUIMENU_PLAYER *InitMenu( GUIMENU *menu, int x, int y );
extern int UpdateMenu( GUIMENU_PLAYER *player );
extern int ShutdownMenu( GUIMENU_PLAYER *player );
/****************************************************************************/
extern GUIMENU *ActiveMenu;
extern BITMAP *DialogGuiScreen;
//
#ifdef __cplusplus
}
#endif
#endif //_TDGUI_H_

